#!/usr/bin/perl

# JPPS (Jeb Perl Ping Stats), v1.4.5, by Jeb@jeb.com.fr
# Sorry all comment and History is in french

# Usage: ./jpps.pl file (here 10 line are diplayed)
#    or: /jpps.pl -f=<File> [-l=<number of line to display>] [-s=<seq number of first ping]

# Version 1.4.5 : bug fixe pour ping mdk, ajout de -s
# Version 1.4.4 : bug fixe
# Version 1.4.3 : bug fixe & amelioration
# Version 1.4.2 : remplacement des while par des for
# Version 1.4.1 : rajout de $graphdot qui defini les charactere pour le graph
# Version 1.4.0 : optimisation (perl -w est ok)
# Version 1.3.4 : si ping max > ligne du graph valeur arondi des tranches 
                  # commentage du bordel de quelque 2xx lignes
# Version 1.3.3 : donne temps pour stats et graph
# Version 1.3.2 : passe en arg du nb ligne
# Version 1.3.1 : en html (cgi) le graph et ds un tableau
# Version 1.3   : recodage graph
# Version 1.2.3 : si ping max > 10ms valeur arondi des tranches
# Version 1.2.2 : correction de l'affichage de l'ip si c'est un dns
# Version 1.2.1 : un peu d'alignement dans le graph :p et optimisation
# Version 1.2   : petit graphique en plus :)
# Version 1.1.1 : rajout du temps d'execution et dit quel ip est ping
# Version 1.1   : utilisable en shell ou cgi
# Version 1.0.2 : Ping Perdu
# Version 1.0.1 : moyenne des ping
# Version 1.0   : ping mini | ping max

$startat = time();
$lg=10;
$seq=0;
$graphdot="-";

if (defined $ENV{REQUEST_METHOD}) {
	print "Content-type: text/html\n\n<html><body>\n";
	($tmp) = $ENV{'QUERY_STRING'};
	@values = split(/&/,$tmp);
		foreach $i (@values) {
		($varname, $mydata) = split(/=/,$i);
		if ($varname eq "f") { $filename=$mydata }
		if ($varname eq "l") { $lg=$mydata }
		if ($varname eq "s") { $seq=$mydata }
	}
}

else {
	($filename) = @ARGV;
	foreach $i (@ARGV) {
		($varname, $mydata) = split(/=/,$i);
		if ($varname eq "-f") { $filename=$mydata }
		if ($varname eq "-l") { $lg=$mydata }
		if ($varname eq "-s") { $seq=$mydata }
	}
}

if (defined $filename) {} else
	{
		if (defined $ENV{REQUEST_METHOD}) {
		        print "Usage: ?f=File&l=nb number of line to display&s=seq number of first ping<br>\n";
			print "l= and s= are optional";
                        exit;
		}
		else {
			print "Usage: $0 -f=File [-l=nb number of line to display] [-s=seq number of first ping]\n";
			exit;
		}
	}

$tmpnbping = $seq; $max = 0; $min = 1000; $nbping = 0; $perdu = 0; $nb = 0; $moy = 0; $who = 0;

open(PING, "<$filename");

$data = <PING>;
if ($data eq "") { print "Fichier $filename inexistant ou non accessible\n"; exit; }

if ( $data =~ /PING\s+(.*)\s\((.*)\):/ ) {
if ($1 eq $2) { $ip = $1 }
else { $ip = "$1 ($2)"; }
}

while(<PING>) {

	if ( $_  =~ /.*seq=(\d+).*time=(\d+)\.?(\d+)?.*/ ) {
		if ($1 eq $tmpnbping) {
			$tmpnbping=$tmpnbping+1;
		}
		elsif ($1 < $tmpnbping) {
			$nbping = $nbping + $tmpnbping;
			$tmpnbping = $1 + 1;
		}
		else {
#	print "$tmpnbping && $1\n";
			$perdu = $1 - $tmpnbping + $perdu;
			$tmpnbping = $1 + 1;
		}
		$tt = "$2.$3";
		$moy = $moy + $tt;
		$nb = $nb + 1;
		if ($tt > $max) { 
			$max = $tt;
			$nummax = $1;
		}
		if ($tt < $min) {  
			$min = $tt;
			$nummin = $1;    
		}
	}
}

$nbping = $nbping + $tmpnbping - $seq;

$moy= $moy/$nb;
$lostpourcent= $perdu/$nbping*100;

if (defined $ENV{REQUEST_METHOD}) {
if ($ip ne "") { print "-- Ping of $ip (file $filename) --\n<br>"; }
else           { print "-- Ping from file $filename --\n<br>"; }
print "   Ping mini: ".$min."ms at ping number $nummin\n<br>   Ping maxi: ".$max."ms at ping number $nummax\n<br>   Average: ".$moy."ms\n<br>";
print "   Ping lost: $perdu of $nbping ($lostpourcent%)\n<br>\n";
} 
else
{
if ($ip ne "") { print "-- Ping of $ip (file $filename) --\n"; }
else           { print "-- Ping from file $filename --\n"; }   
print "   Ping mini: ".$min."ms at ping number $nummin\n   Ping maxi: ".$max."ms at ping number $nummax\n   Average: ".$moy."ms\n";
print "   Ping lost: $perdu of $nbping ($lostpourcent%)\n"; 
}


close(PING);

$date = scalar localtime;
$mtime = time();
$dif = $mtime - $startat;

if (defined $ENV{REQUEST_METHOD}) { print "-- Statistique generated in $dif secondes at $date --<br>\n"; }
else { print "-- Statistique generated in $dif secondes at $date --\n"; }

open(PING, "<$filename");

$etp=$max/$lg;
#graph de x ms en x ms

for ($i=0; $i <= $lg; $i++) {
	if ($max < $lg) {
 		if ($i eq $lg) { $s[$i]=$max; }
		else           { $s[$i]=$etp*$i; $s[$i]=~ /(\d)\.(\d)(\d)(\d)/; $s[$i]=$&; }
	}
	else {
		if ($i eq $lg) { $s[$i]=$max; }
		else           { $s[$i]=int($etp*$i); }
	}
}
#on donne la valeur de chaque tranche dans $s

$s[0]=0;
for ($j=0; $j ne $lg; $j++) {$e[$j]=0;}
while(<PING>) {
	if ( $_  =~ /.*time=(\d+)\.?(\d+)?.*/ ) {

		$p="$1.$2";
		for ($i=0; $i ne $lg; $i++) {
			if ($p <= $s[$i+1] && $p > $s[$i]) { $e[$i]=$e[$i]+1; }
		}
	}
}
# $e = le nb de ping dans la classe 0,1,2,3...

close(PING);

for ($i=0; $i ne $lg; $i++) { if ($who < $e[$i]) { $who=$e[$i]; } }
# $who contient le plus gros nb de ping ds une classe ($e)

if (defined $ENV{REQUEST_METHOD}) { $div=$who/80;}
else { $div=$who/51; }
# on fait un facteur de / pour que ca rentre sur le shell/page web

for ($i=0; $i ne $lg; $i++) { $nb[$i]=int($e[$i]/$div); }
# on divise le contenu de chaque classe $e ca va ds $nb (de point a faire)

for ($i=0; $i ne $lg; $i++) { $p[$i]=""; }


for ($i=0; $i ne $lg; $i++) {
	for ($j=0; $j ne $nb[$i]; $j++) { $p[$i]="$p[$i]$graphdot"; }
}
# on a le nb de point a faire dans $p

for ($i=0; $i ne $lg; $i++) { $t[$i]="   $s[$i]-".$s[$i+1]."ms"; }
# on cree l'amorse de la ligne.. (1-2ms)

if (defined $ENV{REQUEST_METHOD}) { 
	print "<table>\n";
	for ($i=0; $i ne $lg; $i++) { print "<tr><td align=right>$t[$i]$esp[$i] :</td><td>$p[$i]    $e[$i]</td></tr>\n"; }
	print "</table>\n";
}
else {
	for ($i=0; $i ne $lg; $i++) { $es[$i]=17-length($t[$i]); }


	for ($i=0; $i ne $lg; $i++) { $esp[$i]=""; }

	for ( $i=0; $i ne $lg; $i++) {
		for ( $j=0; $j ne $es[$i]; $j++) {
                	$esp[$i]="$esp[$i] ";
        	}
	}


	for ($i=0; $i ne $lg; $i++) { print "$t[$i]$esp[$i] : $p[$i]    $e[$i]\n"; }
}
# bordel pour align et faire la ligne :)

$date = scalar localtime;
$finishat = time();
$dif = $finishat - $mtime;

if (defined $ENV{REQUEST_METHOD}) { print "-- Graph generated in $dif secondes at $date --\n</body></html>"; }
else { print "-- Graph generated in $dif secondes at $date --\n"; }

# voila un script bof ;)
